{ This is the input data:  A;  B;  N;  Sequence_of_0_and_1;  2 :
2
4
10
010100100100010001111011000010100110011110000100100111100100000002


                    -  
                  ---------------------------------------
    (   10-     - I )

      A, B, N (A<=B<12,N<=20)     0  1, -
   2.          A  B, 
   -    .       
        .      -
     ,     .    -
     - N  -   N- -  
   .        , 
         ,     -
     .       2
 .
       ,        -
 .      2 MB,        -
       0  1, .  A  B
    12,      c[i,j],   
    i   j      .   -
  ,    ,      -
  .    .    
 c[].           -
   A  B,      .  val[i]  
  ,   i      .  ,  -
         .    
         , val[i]   --
    val[i].   ,    i   -
    .        
         i.    -
   -         -
   .     ,    
    i,      .     -
     .       i   val
          - c[i,val]. 
   ,    ,   - 
     -     : -
  ""      ""  (2^i-1).   
 -      i,     A  B, 
    i=A..B.        -
   A  B.    :     
  ( c[A..B,....]).       
   c     ,    -
 .         ,
         .   
 N      0   .
}

CONST InFileName = 'contact.pas';
      OutFileName = '';
      MaxAB = 12;

      BitMask: array[1..MaxAB] of longint =
       (1,3,7,15,31,63,127,255,511,1023,2047,4095);

TYPE TCount = array[0..1 shl MaxAB-1] of longint;

VAR A,B,N: integer;
    c: array[1..MaxAB] of ^TCount;


Procedure WriteOutput; {     }
Var OutF: Text;
    Count: longint;

  Procedure FindMaximalCount;
  Var i,j:integer;
  Begin
    Count:=0;
    for i:= a to b do
      for j:= 0 to BitMask[i] do
        if c[i]^[j] > Count then
          Count:= c[i]^[j];
  End;

  Procedure WriteToFileAllCount;
     Function GetValue(len:integer;val:longint): string;
     Var s: string; {  ,   val   len}
         i: integer;
     Begin
       s:= '';
       for i:= 1 to len do
         begin
           s:= chr(val mod 2 + ord('0')) + s;
           val:= val div 2;
         end;
       GetValue:= s;
     End;
  Var i,j: integer;
  Begin
    for i:= b downto a do
      for j:= BitMask[i] downto 0 do
        if c[i]^[j] = Count then
          begin
            c[i]^[j]:= 0;
            Write(OutF,' ',GetValue(i,j));
          end;
  End;

Begin
  Assign(OutF,OutFileName); Rewrite(OutF); WriteLn(OutF);
  for N:= 1 to N do
    begin{N          }
      FindMaximalCount;
      if Count = 0 then break;
      Write(OutF,Count);
      WriteToFileAllCount;
      WriteLn(OutF);
    end;
  Close(OutF);
End;


Procedure Solve; {  c[]       }
Var i,value: integer;
    info: array[1..MaxAB] of
       record len:integer; val:longint; end;
    F: Text;
    ch: char;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,A); ReadLn(F,B); ReadLn(F,N);

  for i:= A to B do
    begin
      GetMem(c[i], (1 shl i)*sizeof(longint));
      FillChar(c[i]^, (1 shl i)*sizeof(longint), 0);
    end;
  FillChar(info,SizeOf(info),0);

  repeat
    Read(f,ch); if ch = '2' then Break;
    value:= ord(ch) - ord('0');
    for i:= A to B do
      with info[i] do
        begin
          if len < i then inc(len);
          val:= (val shl 1) + value;
          val:= val and BitMask[i];
          if len = i then inc(c[i]^[val]);
        end;
  until false;

  Close(F);
End;

BEGIN
  Solve;
  WriteOutput;
END.