{ This is the input data:
10
22
4 -1
1 7 -1


                           
                          --------------------
            (10-     -  I)

   N .      :
   *  1 -     ,    
  - ,   ,  ,    , 
   *  2 -       
   *  3 -       
   *  4 -           3k+1
 .. (1,4,7,...)
    C,      ,   
      .     .
     C        .
   ,        N-
 ,      , ..   
     C    ( C ).
         N (0 < N < 100).   
      C (0 < C < 10000).       -
 ,  ,   ,   '-1'.  
    ,   .     '-1'.
      ,    .   
   .

        ,     ,    
             . -
      ,        
 .    ,     
  16          : [],
 [1], [2], [3], [4], [1,2], [1,3], [1,4], [2,3], [2,4], [3,4], [1,2,3], [1,2,
 4], [1,3,4], [2,3,4]  [1,2,3,4].        16-
     ,       ,    -
 ,       ,    ,   
  .   C   ,      ,
        - [], [1,2], [1,3], [1,4], [2,3],
 [2,4], [3,4],  [1,2,3,4],      - ,   
        .       -
   C   -   .     -
    Possible,       
   (o1,o2,o3  o4)    (  )   C
         . -
       16-       -
       .    ,
           ( -
  [1]  [2,3]  ).      
     (      2),  
     ,    . 
     . -   C  
    ,       
  ,            C -
 .
}


CONST InFileName  = 'PARTY.PAS';
      OutFileName = '';
      MaxN = 200;

TYPE TLamps = array[1..MaxN] of char; {   - 0, 1  ?}

VAR L: TLamps; {      }
    N,C: integer;

Procedure ReadData; {   - N, C  L[1..N]}
Var F: Text;
    v: integer;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N); Readln(F,C);
  FillChar(L,SizeOf(L),'?');
  repeat
    Read(F,v);
    if v = -1 then Break;
    L[v]:='1';
  until false;
  ReadLn(F);
  repeat
    Read(F,v);
    if v = -1 then break;
    L[v]:='0';
  until false;
  Close(F);
End;

Procedure Solve; {     }
Var R: TLamps;
    o1,o2,o3,o4: boolean;
    OutF: Text;

  Procedure Change(bit:integer); {      bit}
  Begin
    if R[bit] = '0' then R[bit]:= '1'
    else R[bit]:= '0';
  End;

  Procedure Op1; {  R  1}
  Var i: integer;
  Begin
    for i:= 1 to N do Change(i);
  End;

  Procedure Op2; {  R  2}
  Var i: integer;
  Begin
    for i:= 1 to N do
      if odd(i) then Change(i);
  End;

  Procedure Op3; {  R  3}
  Var i: integer;
  Begin
    for i:= 1 to N do
      if not odd(i) then Change(i);
  End;

  Procedure Op4; {  R  4}
  Var i: integer;
  Begin
    for i:= 1 to N do
      if i mod 3 = 1 then Change(i);
  End;

  Procedure Print; { R[1..N]   }
  Var i: integer;
  Begin
    For i:= 1 to N do
      Write(outf,R[i]);
    Writeln(outf);
  End;

  Function Possible: boolean; {  ,   
       o1,o2,o3,o4     C  L[1..N]}
  Var i,NewC: integer;
  Begin
    Possible:=false;
    NewC:= C - byte(o1) - byte(o2) - byte(o3) - byte(o4);
    if (NewC < 0) or (odd(NewC)) then Exit;
    FillChar(R,N,'1');
    if o1 then Op1;
    if o2 then Op2;
    if o3 then Op3;
    if o4 then Op4;
    {  R[1..N]      L[1..N]}
    for i:= 1 to N do
      if (L[i]='0') or (L[i]='1') then
        if L[i] <> R[i] then Exit;
    Possible:=true;
  End;

Begin
  Assign(OutF,OutFileName); Rewrite(OutF);
  {  ,    16-  }
  for o1:= false to true do
    for o2:= false to true do
      for o3:= false to true do
        for o4:= false to true do
          if Possible then Print;
  WriteLn(OutF);
  Close(OutF);
End;

BEGIN
  ReadData;
  Solve;
END.